Package org.codehaus.groovy.vmplugin.v7

## Class Java7

- java.lang.Object
- - org.codehaus.groovy.vmplugin.v5.Java5
  - - org.codehaus.groovy.vmplugin.v6.Java6
    - - org.codehaus.groovy.vmplugin.v7.Java7

- All Implemented Interfaces:
    `VMPlugin`

      @Deprecated
      public class Java7
      extends Java6

  Deprecated.
  Java 7 based functions.

  For crude customization, you can add your own methods to your own version and place it on the classpath ahead of this one.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Java7()` | Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Object` | `getInvokeSpecialHandle​(Method method, Object receiver)` | Deprecated. Returns a handle with bound receiver to invokeSpecial the given method.
    `int` | `getVersion()` | Deprecated. Gives the version the plugin is made for
    `void` | `invalidateCallSites()` | Deprecated.
    `Object` | `invokeHandle​(Object handle, Object[] args)` | Deprecated. Invokes a handle produced by #getInvokeSpecialdHandle

    - ### Methods inherited from class org.codehaus.groovy.vmplugin.v5.Java5

      `checkAccessible, checkCanSetAccessible, configureAnnotation, configureAnnotationFromDefinition, configureAnnotationNodeFromDefinition, configureClassNode, configureTypeVariableDefinition, configureTypeVariableReference, getElementCode, getPluginDefaultGroovyMethods, getPluginStaticGroovyMethods, makeParameter, processParameters, setAdditionalClassInformation, transformMetaMethod, transformMetaMethod, trySetAccessible`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.codehaus.groovy.vmplugin.VMPlugin

      `getDefaultImportClasses`

- - ### Constructor Detail

    - #### Java7

          public Java7()

      Deprecated.

  - ### Method Detail

    - #### invalidateCallSites

          public void invalidateCallSites()

      Deprecated.
      Specified by:
        `invalidateCallSites` in interface `VMPlugin`
      Overrides:
        `invalidateCallSites` in class `Java5`

    - #### getVersion

          public int getVersion()

      Deprecated.
      Description copied from interface: `VMPlugin`
      Gives the version the plugin is made for
      Specified by:
        `getVersion` in interface `VMPlugin`
      Overrides:
        `getVersion` in class `Java6`
      Returns:
        7 for jdk7, 8 for jdk8, 9 for jdk9 or higher

    - #### getInvokeSpecialHandle

          public Object getInvokeSpecialHandle​(Method method,
                                               Object receiver)

      Deprecated.
      Description copied from interface: `VMPlugin`
      Returns a handle with bound receiver to invokeSpecial the given method. This method will require at least Java 7, but since the source has to compile on older Java versions as well it is not marked to return a MethodHandle and uses Object instead
      Specified by:
        `getInvokeSpecialHandle` in interface `VMPlugin`
      Overrides:
        `getInvokeSpecialHandle` in class `Java5`
      Returns:
        null in case of jdk<7, otherwise a handle that takes the method call arguments for the invokespecial call

    - #### invokeHandle

          public Object invokeHandle​(Object handle,
                                     Object[] args)
                              throws Throwable

      Deprecated.
      Description copied from interface: `VMPlugin`
      Invokes a handle produced by #getInvokeSpecialdHandle
      Specified by:
        `invokeHandle` in interface `VMPlugin`
      Overrides:
        `invokeHandle` in class `Java5`
      Parameters:
        `handle` - the handle
        `args` - arguments for the method call, can be empty but not null
      Returns:
        the result of the method call
      Throws:
        `Throwable`